<template>
    <div class="modal">
        <div class="modal-mask"></div>
        <button class="close-btn button-icon" @click="closeModal();">
            <i class="icon-close"></i>
        </button>
        <div class="modal-wrapper">
            <div class="modal-sidebar">
                <div>
                    <h2 v-if="edit">Edit <br>Legal <br> Participant</h2>
                    <h2 v-else>Create <br>Legal <br>Participant</h2>
                </div>
                <div>
                    <div class="info user">
                        <h3>Owner</h3>
                        <UserProfile />
                    </div>
                    <InfoBox title="Creation date" text="17:14:12 <br> 19 Nov 2024" />
                </div>
            </div>
            <div class="modal-content">
                <!-- ==== STEP 1 - Legal Participant Info ====  -->
                <div id="step-1" class="step" v-show="currentStep === 1">
                    <form id="legal-participant-step-1" @submit.prevent="handleSubmit">
                        <div class="title">
                            <span class="step-number">1</span>
                            <h2>Legal Participant Info</h2>
                            <p>You can create new datasets using either the Bulk or Streaming method.<br>Choose the option that best suits your needs and get started now!</p>
                        </div>
                        <div class="step-default">
                            <div class="field field-modal-big-label">
                                <label for="" class="label"><span>1.</span>Domain name</label>
                                <input type="text" name="name" required :value="edit ? data?.name : ''" :disabled="edit" data-error-message="Fill in this field." onkeypress="return event.charCode != 32"  />
                                <span class="max-characters">
                                    <span class="text">Max. 30 characters</span><span class="separator"></span> <button> <i class="icon-delete"></i></button>
                                </span>
                            </div>
                        </div>
                        <div class="step-default">
                            <div class="field field-modal-big-label">
                                <label for="legal-url" class="label"><span>2.</span>Legal Participant URL</label>
                                <input type="text" name="legal-url" required data-error-message="Fill in this field." onkeypress="return event.charCode != 32"  />
                                <span class="max-characters">
                                    <span class="text">Max. 30 characters</span><span class="separator"></span> <button> <i class="icon-delete"></i></button>
                                </span>
                            </div>
                        </div>
                        <div class="step-default">
                            <div class="field field-modal-big-label">
                                <label for="legal-name" class="label"><span>3.</span>Legal Name</label>
                                <input type="text" name="legal-name" required data-error-message="Fill in this field." onkeypress="return event.charCode != 32"  />
                                <span class="max-characters">
                                    <span class="text">Max. 30 characters</span><span class="separator"></span> <button> <i class="icon-delete"></i></button>
                                </span>
                            </div>
                        </div>
                        <div class="step-default">
                            <div class="field field-modal-big-label">
                                <label for="headquarter-address" class="label"><span>4.</span>Headquarter Address</label>
                                <input type="text" name="headquarter-address" required data-error-message="Fill in this field." onkeypress="return event.charCode != 32"  />
                                <span class="max-characters">
                                    <span class="text">Max. 30 characters</span><span class="separator"></span> <button> <i class="icon-delete"></i></button>
                                </span>
                            </div>
                        </div>
                        <div class="step-default">
                            <div class="field field-modal-big-label">
                                <label for="legal-address" class="label"><span>5.</span>Legal Address</label>
                                <input type="text" name="legal-address" required data-error-message="Fill in this field." onkeypress="return event.charCode != 32"  />
                                <span class="max-characters">
                                    <span class="text">Max. 30 characters</span><span class="separator"></span> <button> <i class="icon-delete"></i></button>
                                </span>
                            </div>
                        </div>
                        <div class="step-default">
                            <div class="field field-modal-big-label">
                                <label for="legal-registratrion-type" class="label"><span>6.</span>Legal Registration Type</label>
                                <CustomSelect class="col" :options="legalRegistratrionType" defaultTitle="Select a type" name="legal-registratrion-type" />
                            </div>
                        </div>
                        <div class="step-default">
                            <div class="field field-modal-big-label">
                                <label for="legal-registratrion-number" class="label"><span>7.</span>Legal Registratrion Number</label>
                                <input type="text" name="legal-registratrion-number" required data-error-message="Fill in this field." onkeypress="return event.charCode != 32"  />
                                <span class="max-characters">
                                    <span class="text">Max. 30 characters</span><span class="separator"></span> <button> <i class="icon-delete"></i></button>
                                </span>
                            </div>
                        </div>
                    </form>
                </div>
            </div>
            <div class="modal-buttons-area">
                <button :class="['button-stroke-transparent rounded', currentStep === 1 && 'hide']" id="previous-step" @click="previousStep">Back</button>
                <button class="button-secondary orange" id="next-step" @click="handleNextClick"><span v-if="edit">Save</span><span v-else>Create</span></button>
            </div>
        </div>
    </div>
    <ClientOnly>
        <Teleport to="#modals-container">
            <ModalsModalFeedback v-if="showFeedback" :feedback="feedbackMessage" @toggle="close"/>
        </Teleport>
    </ClientOnly>
</template>

<script setup lang="ts">
const props = defineProps({
    edit: { 
        type: Boolean, 
        required: false 
    },
    data: {
        type: Object,
        required: false
    }
});

const legalRegistratrionType = [
    { id: 1, name: 'vatID' },
    { id: 2, name: 'leiCode' },
    { id: 3, name: 'EORI' }
];

const emit = defineEmits(['toggle', 'refresh-data']);

const closeModal = () => {
    emit('toggle');
    emit('refresh-data');
}

const feedbackMessage = ref({ type: '', message: '' });
const showFeedback = ref(false);
const close = () => {
    showFeedback.value = false;
};

const currentStep = ref<number>(1);


const handleSubmit = () => {};

const handleNextClick = () => {
      if (currentStep.value === 1) {
        // Trigger form submission and validation only on step 1
        handleSubmit();
      } else {
        // Proceed to the next step without form submission
        nextStep();
      }
    }

const nextStep = () => {
    if (currentStep.value < 2) {
        currentStep.value++;
    }
}

const previousStep = () => {
    if (currentStep.value > 0) {
        currentStep.value--;
    }
}
</script>